/**
 * Copyright (c) 2000-present Liferay, Inc. All rights reserved.
 *
 * The contents of this file are subject to the terms of the Liferay Enterprise
 * Subscription License ("License"). You may not use this file except in
 * compliance with the License. You can obtain a copy of the License by
 * contacting Liferay, Inc. See the License for the specific language governing
 * permissions and limitations under the License, including but not limited to
 * distribution rights of the Software.
 *
 *
 *
 */

package com.liferay.poshi.runner.var.type;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;

/**
 * @author Yi-Chen Tsai
 */
public class HashesTable extends BaseTable<Map<String, String>> {

	@Override
	public List<Map<String, String>> getTable() {
		return _hashesTable;
	}

	@Override
	public Iterator<Map<String, String>> iterator() {
		return _hashesTable.iterator();
	}

	protected HashesTable(List<List<String>> rawData) {
		super(rawData);

		if (rawData.size() < 2) {
			return;
		}

		List<String> rowKeys = rawData.get(0);

		for (int i = 1; i < rawData.size(); i++) {
			List<String> rowEntries = rawData.get(i);

			LinkedHashMap<String, String> hashesRow = new LinkedHashMap<>();

			for (int j = 0; j < rowEntries.size(); j++) {
				hashesRow.put(rowKeys.get(j), rowEntries.get(j));
			}

			_hashesTable.add(hashesRow);
		}
	}

	private final List<Map<String, String>> _hashesTable = new ArrayList<>();

}